var nw = {
    gui: require("nw.gui"),
    // win: require("nw.gui").Window.get(),
    // spawn: require("child_process").spawn,
    exec: require("child_process").exec,
    platform: process.platform,
    fs: require("fs"),
    // request: require("request")
}
var utils = require('./js/utils.js'),
    tray = require('./js/tray.js'),
    client = require('./js/client.js'),
    keyboard = require('./js/keyboard.js'),
    screenshot = require('./js/screenshot.js'),
    login = require('./js/login.js'),
    update = require('./js/update.js'),
    upload = require('./js/upload.js');

$(document).ready(function() {

    utils.checkFoldersFiles(nw, function() {
        utils.parseConfigIni(function(config) {
            if (config && config.account.token != 'notset' && config.account.token) {
                client.checkToken($, config.account.token, function(error, data) {
                    if (error) {
                        hideProgress();
                    } else {
                        showProgress("Success ! Starting application ...");
                        setTimeout(function() {
                            hideProgress();
                            login.loginSuccess(nw, config.account.token);
                        },1000)
                    }
                });
            }

            update.check($, nw);
        });
    });


    $("#input-username").focus();
    $("#forgot_link").on('click', function(e) {
        e.preventDefault();
        nw.gui.Shell.openExternal('http://www.pics.rs/forgot_password');
    });
    $(".application-quit").on('click', function() {
        nw.gui.App.quit();
    });

    $("#login-form").on('submit', function(e) {
        e.preventDefault();
        var $this = $(this),
            username = $this.find('input').filter('[name="username"]').val(),
            password = $this.find('input').filter('[name="password"]').val();

        showProgress();
        client.checkLogin($, username,password, function(error, token) {
            if (error) {
                showProgress("Login failed !");
                setTimeout(function() {
                    hideProgress();
                }, 2000)
            } else {
                showProgress("Login successfull !");
                showProgress("Checking your login details ...");

                utils.addConfigIni('token', token, 'account');

                client.checkToken($, token, function(error, data) {
                    if (error) {
                        console.log('Token invalid', token);
                        hideProgress();
                    } else {
                        showProgress("Success ! Starting application ...");
                        setTimeout(function() {
                            hideProgress();
                            login.loginSuccess(nw, token);
                        },1000)
                    }
                });
            }
        });
    });


});

function showProgress( text ) {
    var $loginProgress = $("#login-progress");
    $("#login-form").hide();
    $loginProgress.show();
    if (!!text) {
        $loginProgress.find('i').text( text );
    } else {
        $loginProgress.find('i').text( "Please wait ..." );
    }
};

function hideProgress() {
    $("#login-form").show();
    $("#login-progress").hide();
    $("#input-username").focus();
};