module.exports = {
    bindKeys: function(nw, callback) {
        var screenshotModifier = window.config.keyboard.screenshot_modifier,
            screenshotHotkey = window.config.keyboard.screenshot_hotkey,
            ssKey = screenshotModifier + '+' + screenshotHotkey;

        if (!screenshotModifier) {
            window.alert('Error!\n\nInvalid screenshot modifier, can\'t bind screenshot hotkey ! Please check Pics.rs options !');
            return;
        }
        if (!screenshotHotkey) {
            window.alert('Error!\n\nInvalid screenshot hotkey, can\'t bind screenshot hotkey ! Please check Pics.rs options !');
            return;
        }
        window.screenshotShortcut = new nw.gui.Shortcut({
            key : ssKey,
            active : function() {
                callback();
            },
            failed : function(msg) {
                window.alert('Error!\n\nWe can\'t bind hotkey "'+ssKey+'", most likely that combination is already used by system or some other app.\n'+
                             'Try going into options and changing hotkey to something else.\n\n' +
                             'This is the error we received:' + msg);
            }
        });
        nw.gui.App.registerGlobalHotKey(window.screenshotShortcut);
    },
    unbindKeys: function(nw) {
        window.screenshotShortcut && nw.gui.App.unregisterGlobalHotKey(window.screenshotShortcut);
    }
}