var nw = {
    gui: require("nw.gui"),
    exec: require("child_process").exec
}
var utils = require('./js/utils.js');
var sound = require('./js/sound.js');
var AutoLaunch = require('auto-launch');

var nwAppLauncher = new AutoLaunch({
    name: 'Pics.rs Screenshot client'
});

$(document).ready(function() {
    $(".button-set").buttonset();

    $(".close-window").on('click', function() {
        var win = nw.gui.Window.get();
        win.close();
    })

    utils.parseConfigIni(function(config) {
        console.log('Loaded config', config);

        if (!config.keyboard) config.keyboard = [];
        if (!config.system) config.system = [];
        if (!config.image) config.image = [];
        if (!config.sound) config.sound = [];

        var allSounds = utils.getAllSounds();
        console.log('Sounds', utils.getAllSounds());


        $('.sound_select').empty().append('<option value="">Disabled</option>');
        for (var i = 0; i<allSounds.length; i++) {
            var item = allSounds[i];
            $('.sound_select').append('<option value="'+item+'">'+item+'</option>');
        }

        // Keyboard stuff
        $('.screenshot_select').val( config.keyboard['screenshot_hotkey'] );
        $('.screenshot_select').on('change', function(evnt) {
            $('.hotkey_changed').css({'visibility':'visible', 'display':'none'}).fadeIn();
            utils.addConfigIni('screenshot_hotkey', $(evnt.currentTarget).val(), 'keyboard');
        });
        $('.modifier_buttons').find('button').on('click', function(evnt) {
            var $item = $(evnt.currentTarget),
                name = $item.prop('value'),
                active = $item.hasClass('active'),
                modifierKeys = [];

            $('.modifier_buttons').find('button.active').each(function() {
                modifierKeys.push( $(this).prop('value') );
            });
            if (!modifierKeys.length) {
                // hack to trigger Metro button active, preventDefault doesnt work
                $item.trigger('click');
                return;
            }

            $('.hotkey_changed').css({'visibility':'visible', 'display':'none'}).fadeIn();
            utils.addConfigIni('screenshot_modifier', modifierKeys.join('+'), 'keyboard');
        });
        var modifiers = config.keyboard.screenshot_modifier || [];
        $('.modifier_buttons').find('button').each(function(id,item) {
            var $item = $(item),
                name = $item.prop('value');
            $item.toggleClass('active', modifiers.indexOf(name) > -1);
        });

        // System stuff
        $('.system_input').each(function(id,item) {
            var name = $(item).attr('name');
            $(item).prop( 'checked', config.system[name]>0 ? true : false );
        });
        $('.system_input').on('change', function(evnt) {
            var $item = $(evnt.currentTarget),
                name = $item.attr('name'),
                value = $item.prop('checked') ? 1 : 0;

            utils.addConfigIni(name, value, 'system');
        });
        $('.start_on_boot').on('change', function(evnt) {
            var enableBoot = $(evnt.currentTarget).prop('checked');

            if (enableBoot) {
                nwAppLauncher.enable(function(err){
                    console.log('Start on boot Enabled',err);
                });
            } else {
                nwAppLauncher.disable(function(err) {
                    console.log('Start on boot Disabled', err);
                });
            }
        });

        // Sound stuff
        $('.sound_select').each(function(id,item) {
            var name = $(item).attr('name');
            $(item).val( config.sound[name] );
        });
        $('.sound_select').on('change', function(evnt) {
            var $item = $(evnt.currentTarget),
                name = $item.attr('name'),
                value = $item.val();

            utils.addConfigIni(name, value, 'sound');
            sound.playSound(nw, './sounds/' + value);
        });

        // Image stuff
        $('.downscale_select').val( config.image['retina_image_resize'] );
        $('.downscale_select').on('change', function(evnt) {
            var $item = $(evnt.currentTarget),
                name = $item.attr('name'),
                value = $item.val();

            utils.addConfigIni(name, value, 'image');
        });

    })
});