var retina = require('./retina.js'),
    lwip = require('lwip');

module.exports = {
    roundDecimal: function( number ) {
        return Math.round(number * 100) / 100
    },
    needResize: function() {
        return window.config.image.retina_image_resize || 'auto';
    },
    doResize: function(filename, callback) {
        var scale = 1;

        switch (this.needResize()) {
            case 'auto': {
                if (retina.isRetinaDisplay()) {
                    scale = 0.5;
                }
                break;
            }
            case 'disabled': {
                scale = 1;
                break;
            }
            default: {
                scale = this.roundDecimal( 1 / parseInt(this.needResize(), 10) );
                break;
            }
        }

        if (scale === 1) {
            callback();
        } else {
            lwip.open( filename, function(err, image){
                image.scale(scale, scale, 'lanczos', function(err, image){
                    image.sharpen(50, function(err, image) {
                        image.toBuffer('png', function(err, buffer){
                            image.writeFile( filename, function(err){
                                callback();
                            });
                        });
                    });
                });
            });
        }

    }
}