var utils = require('./utils.js'),
    sound = require('./sound.js'),
    upload = require('./upload.js'),
    resize = require('./resize.js');

module.exports = {
    invokeGrab: function(nw, callback) {
        var d = new Date(),
            screenshotsFolder = utils.getScreenshotsFolder(),
            filename = "Screenshot " + d.getFullYear() + '-' + d.getMonth() + '-' + d.getDate() + ' ' + d.getHours() + '.' + d.getMinutes() + '.' + d.getSeconds() +'.png';

        filename = screenshotsFolder + '/' + filename;

        console.log('Invoking grab into this file', filename);

        if (nw.platform == "darwin") {
            utils.executeCommand(nw, 'screencapture -x -i "' + filename + '"', function() {
                callback( filename );
            });

        } else {
            console.log('Platform not supported !');
        }
    },
    takeSS: function(nw) {
        var self = this;

        this.invokeGrab(nw, function(filename) {
            nw.fs.exists(filename, function (exists) {
                if (exists) {
                    sound.playCapture(nw);
                    resize.doResize(filename, function() {
                        upload.doUpload(filename, function(url) {
                            sound.playUploaded(nw);
                            utils.executeCommand(nw, 'echo "'+url+'" | pbcopy');
                            self.deleteIfNeeded(nw, filename);
                        });
                    });
                }
            });
        });
    },
    deleteIfNeeded: function(nw, filename) {
        if ( !window.config.system.save_screenshots_in_folder ) {
            nw.fs.unlinkSync(filename);
        }
    },
}