var keyboard = require('./keyboard.js'),
    screenshot = require('./screenshot.js'),
    client = require('./client.js');

module.exports = {
    makeTray: function(nw) {
        var self = this;
        window.tray = new nw.gui.Tray({ icon: 'img/icon.png', iconsAreTemplates: true });

        var menu = new nw.gui.Menu();
        menu.append(new nw.gui.MenuItem({ label: 'Capture screenshot' }));
        menu.append(new nw.gui.MenuItem({ label: 'Options' }));
        menu.append(new nw.gui.MenuItem({ label: 'About' }));
        menu.append(new nw.gui.MenuItem({ label: 'Logout' }));
        menu.append(new nw.gui.MenuItem({ label: 'Exit' }));
        window.tray.menu = menu;

        if (nw.platform == 'darwin') {
            win = nw.gui.Window.get();
            var nativeMenuBar = new nw.gui.Menu({ type: "menubar" });
            nativeMenuBar.createMacBuiltin("Pics.RS Client");
            win.menu = nativeMenuBar;
        }

        menu.items[0].click = function() {
            screenshot.takeSS(nw);
        };
        menu.items[1].click = function() {
            window.optionsWindow && window.optionsWindow.close();
            window.optionsWindow = nw.gui.Window.open('options.html', {
            // position: 'center',
                width: 700,
                height: 555,
                frame: false,
                resizable: false
            });
            setTimeout(function() {
                window.optionsWindow.focus();
            },100);
        };
        menu.items[2].click = function() {
            window.aboutWindow && window.aboutWindow.close();
            window.aboutWindow = nw.gui.Window.open('about.html', {
            // position: 'center',
                width: 600,
                height: 340,
                frame: false,
                resizable: false
            });
            setTimeout(function() {
                window.aboutWindow.focus();
            },100);
        };
        menu.items[3].click = function() {
            window.tray.remove();
            window.tray = null;
            menu = null;
            keyboard.unbindKeys(nw);

            client.logout();
            var loginPage = nw.gui.Window.get('index.html');
            loginPage.show();
        };
        menu.items[4].click = function() {
            nw.gui.App.quit();
        };
    },
}