module.exports = {
    API_URL: 'http://api.pics.rs',
    UPDATE_PATH: 'check_version/mac',

    check: function($, nw) {
        if (!parseInt(window.config.system.check_for_updates_on_startup,10)) {
            return;
        }

        var self = this,
            currentVersion = parseFloat(nw.gui.App.manifest.version, 10);

        this.fetchLatestUpdate($, function(data) {
            var latestVersion = parseFloat(data.last_version, 10);
            console.log('Current version', currentVersion);
            console.log('Latest version', latestVersion);
            if (latestVersion>currentVersion) {
                self.promptUpdate(nw, currentVersion, latestVersion, data);
            }
        });
    },

    fetchLatestUpdate: function($, callback) {
        $.ajax({
            type: "POST",
            url: this.API_URL + '/' + this.UPDATE_PATH,
            dataType: 'json'
        }).done(function(data) {
            callback(data);
        });
    },

    promptUpdate: function(nw, currentVersion, latestVersion, data) {
        var confirmMessage =   'Hey there !\n' +
                               'Looks like there is a new awesome update available !\n\n' +
                               'Your version: '+currentVersion+'\n' +
                               'Latest version: '+latestVersion+'\n\n' +
                               'Would you like to visit download page now?';

        if (window.confirm(confirmMessage)) {
            nw.gui.Shell.openExternal('http://www.pics.rs/download');
        }
    }
}